<?php
require_once('../__inc/_start.inc.php');
$_seite = 17;
$erlaubt = pruefeRechte('m_vorstand_anzeigen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'mitgliedzuweisen':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['vid'])){
		$_tmpl->assign('fehler','die ID ist ungltig');
		break;
	}
	else{
		$query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_GET['vid'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Das Vorstandsamt existiert nicht.');
			break;
		}
		$mid = $_db->holeWert();
	}
	$_tmpl->assign('ueberschrift','Vorstandsamt Mitglied zuweisen');
	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG, 'aktion=mitgliedzuweisen&amp;vid='.$_GET['vid']);
	}
	else{
		$_inh .= $_GET['id'];
		$mw_switch = array(
			1 => array('m' => 'Abteilungsleiter', 'w' => 'Abteilungsleiterin'),
			2 => array('m' => 'stellvertretender Abteilungsleiter', 'w' => 'stellvertretende Abteilungsleiterin'),
			3 => array('m' => 'sportlicher Leiter', 'w' => 'sportliche Leiterin'),
			4 => array('m' => 'Schriftfhrer', 'w' => 'Schriftfhrerin'),
			5 => array('m' => 'Kassier', 'w' => 'Kassiererin')
		);
		$query = "SELECT id, mw FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Das Mitglied existiert nicht.');
			require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
			$_inh .= mitgliedwaehlen('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG, 'aktion=mitgliedzuweisen&amp;vid='.$_GET['vid']);
		}
		else{
			$row = $_db->holeZeile();
			$query = "UPDATE ".DB_PREFIX."vorstand
						SET
						  ".(in_array($_GET['vid'],array_keys($mw_switch))?"bezeichnung = '".$mw_switch[$_GET['vid']][$row['mw']]."',":'')."
						  mitgliedid = ".$row['id']."
						WHERE id = '".$_GET['vid']."'";
			$_db->fuehreQueryAus($query);
			require_once(PFAD_INCLUDE.'func/mitglieder_rechtegruppensetzen.inc.php');
			mitglieder_rechtegruppensetzen($mid);
			mitglieder_rechtegruppensetzen($row['id']);
			weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Das Mitglied wurde dem Vorstandsamt zugewiesen');
		}
	}
	break;
case 'aendern':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['id'])){
		$_tmpl->assign('fehler','die ID ist ungltig');
		break;
	}
	if($_GET['id'] < 10){
		$_tmpl->assign('fehler','dieses Vorstandsamt kann nicht bearbeitet werden.');
		break;
	}
	$_tmpl->assign('ueberschrift','Vorstandsamt ndern');
	if(!isset($_POST['speichern'])){
		$query = "SELECT v.id, v.bezeichnung, v.sort, CONCAT(m.vorname,' ',m.nachname) as name
				FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid=m.id
				WHERE v.id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Dieses Amt existiert nicht.');
			break;
		}
		$_tmpl->assign('daten',$_db->holeZeile());
	}
	else{
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['sort'],'leer','Das Feld sort darf nicht leer sein');
		$f .= pruefen($_POST['sort'],'zahl','Das Feld sort muss eine Zahl enthalten');
		$f .= pruefen($_POST['sort'],'maxlaenge','Das Feld sort darf hchstens 3 Ziffern enthalten',3);
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung darf nicht leer sein');
		$f .= pruefen($_POST['bezeichnung'],'minlaenge','Die Bezeichnung muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung darf aus hchstens 50 Zeichen bestehen',50);
		if(empty($f)){
			$query = "UPDATE ".DB_PREFIX."vorstand
						SET sort = ".text_format($_POST['sort'],'db').",
							bezeichnung = '".text_format($_POST['bezeichnung'],'db')."'
						WHERE id = '".text_format($_GET['id'],'db')."'";
			$_db->fuehreQueryAus($query);
			weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Das Vorstandsamt '.$_POST['bezeichnung'].' wurde gendert');
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/17.vorstand-formular.inc.html');
	break;
case 'anlegen':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','Vorstand anlegen');
	if(isset($_POST['speichern'])){
		$f = '';
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f .= pruefen($_POST['sort'],'leer','Das Feld sort darf nicht leer sein');
		$f .= pruefen($_POST['sort'],'zahl','Das Feld sort muss eine Zahl enthalten');
		$f .= pruefen($_POST['sort'],'maxlaenge','Das Feld sort darf hchstens 3 Ziffern enthalten',3);
		$f .= pruefen($_POST['bezeichnung'],'leer','Die Bezeichnung darf nicht leer sein');
		$f .= pruefen($_POST['bezeichnung'],'minlaenge','Die Bezeichnung muss aus mindestens 2 Zeichen bestehen',2);
		$f .= pruefen($_POST['bezeichnung'],'maxlaenge','Die Bezeichnung darf aus hchstens 50 Zeichen bestehen',50);
		if(empty($f)){
			$query = "INSERT INTO ".DB_PREFIX."vorstand
						SET sort = ".text_format($_POST['sort'],'db').",
							bezeichnung = '".text_format($_POST['bezeichnung'],'db')."'";
			$_db->fuehreQueryAus($query);
			$text = 'Das Vorstandsamt '.$_POST['bezeichnung'].' wurde angelegt';
			weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,$text);
		}
		else{
			$_tmpl->assign('daten',$_POST);
			$_tmpl->assign('fehler',$f);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/17.vorstand-formular.inc.html');
	break;
case 'loeschen':
	if(!pruefeRechte('m_vorstand_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!ctype_digit($_GET['id'])){
		$_tmpl->assign('fehler','die ID ist ungltig');
		break;
	}
	if($_GET['id'] < 10){
		$_tmpl->assign('fehler','Dieses Vorstandsamt kann nicht gelscht werden.');
		break;
	}
	$_tmpl->assign('ueberschrift','Vorstandsamt lschen');
	if(!isset($_GET['sicher'])){
		$_tmpl->assign('frage','Soll das Vorstandsamt wirklich gelscht werden?');
		$_tmpl->assign('url', '/mitglieder/vorstand'.TKSWIM_DATEIENDUNG);
		$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
	}
	else{
		$query = "SELECT mitgliedid FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1){
			$_tmpl->assign('fehler','Dieses Vorstandsamt existiert nicht.');
			break;
		}
		$mid = $_db->holeWert();
		if(!is_null($mid)){
			$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid = ".$mid." AND rechtegrid = 4";
			$_db->fuehreQueryAus($query);
		}
		$query = "DELETE FROM ".DB_PREFIX."vorstand WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->fuehreQueryAus($query);
		weiterleiten('/mitglieder/vorstand'.TKSWIM_DATEIENDUNG,'Das Vorstandsamt wurde gelscht');
	}
	break;
default:
	$query = "SELECT v.id, v.bezeichnung, CONCAT(m.vorname,' ',m.nachname) as name
				FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid=m.id
				ORDER BY sort ASC";
	$_db->holeDaten($query);
	$_tmpl->assign('ueberschrift','Vorstand');
	$_tmpl->assign('vorstand',$_db->ergebnis['daten']);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'vorstand',frage:'Soll das Vorstandsamt%%% wirklich gelscht werden?',tabellenid:'vorstand'});");
	$_inh .= $_tmpl->fetch('mitglieder/17.vorstand-uebersicht.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>